commit 9d93e9dfcfbbdab2b4b946acbd0b786086f7d1d1
Author: freddy77 <freddy77>
Date:   Thu Mar 19 15:09:55 2009 +0000

    fix some problems under win32

diff --git a/ChangeLog b/ChangeLog
index 53c3f51..76f7e67 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,7 @@
+Thu Mar 19 16:09:30 CET 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/dblib/unittests/common.c src/replacements/basename.c:
+	- fix some problems under win32
+
 Thu Mar 19 14:36:34 CET 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* misc/prepare_win32.sh: include sql files
 
@@ -1429,4 +1433,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2756 2009/03/19 13:36:46 freddy77 Exp $
+$Id: ChangeLog,v 1.2757 2009/03/19 15:09:55 freddy77 Exp $
diff --git a/src/dblib/unittests/common.c b/src/dblib/unittests/common.c
index fc158ff..cc5549d 100644
--- a/src/dblib/unittests/common.c
+++ b/src/dblib/unittests/common.c
@@ -14,7 +14,7 @@
 
 #include "replacements.h"
 
-static char software_version[] = "$Id: common.c,v 1.30 2009/03/19 13:11:41 freddy77 Exp $";
+static char software_version[] = "$Id: common.c,v 1.31 2009/03/19 15:09:56 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 typedef struct _tag_memcheck_t
@@ -111,6 +111,10 @@ read_login_info(int argc, char **argv)
 	struct { char *username, *password, *servername, *database; char fverbose; } options;
 	
 	BASENAME = tds_basename((char *)argv[0]);
+#ifdef WIN32
+	s1 = strrchr(BASENAME, '.');
+	if (s1) *s1 = 0;
+#endif
 	DIRNAME = dirname((char *)argv[0]);
 	
 	memset(&options, 0, sizeof(options));
diff --git a/src/replacements/basename.c b/src/replacements/basename.c
index a36088d..3dfe522 100644
--- a/src/replacements/basename.c
+++ b/src/replacements/basename.c
@@ -30,7 +30,13 @@
 
 #if ! HAVE_BASENAME
 
-TDS_RCSID(var, "$Id: basename.c,v 1.3 2008/10/02 08:08:00 freddy77 Exp $");
+TDS_RCSID(var, "$Id: basename.c,v 1.4 2009/03/19 15:09:56 freddy77 Exp $");
+
+#ifdef WIN32
+#define TDS_ISDIR_SEPARATOR(c) ((c) == '/' || (c) == '\\')
+#else
+#define TDS_ISDIR_SEPARATOR(c) ((c) == '/')
+#endif
 
 char *tds_basename(char *path)
 {
@@ -39,12 +45,19 @@ char *tds_basename(char *path)
 	if (path == NULL)
 		return path;
 
-	for (p = path + strlen(path); --p > path && *p == '/';)
+	/* remove trailing directories separators */
+	for (p = path + strlen(path); --p > path && TDS_ISDIR_SEPARATOR(*p);)
 		*p = '\0';
 
 	p = strrchr(path, '/');
-
-	return p ? p : path;
+	if (p)
+		path = p + 1;
+#ifdef WIN32
+	p = strrchr(path, '\\');
+	if (p)
+		path = p + 1;
+#endif
+	return path;
 }
 #endif
 

